<?php
/*************************************************************************
 *    @file AprivaPaymentResp.php                                         
 *    @brief This class parses an Apriva XML Inteface response.           
 *           Bare minimum fields have been defined.  Please contact         
 *           Apriva for parsing of additional fields.                     
 *    @author P Heit                                                      
 *    @date Sept 21, 2013                                                 
 *                                                                        
 *    Copyright (c) 2013 by                                               
 *       Apriva LLC                                                       
 *    All rights reserved.                                                
 *                                                                        
 *    This software is furnished under a license and may be used and      
 *    copied only in accordance with the terms of such license and with   
 *    the inclusion of the above copyright notice. This software or       
 *    any other copies thereof may not be provided or otherwise made      
 *    available to any other person or entity. Neither title to nor       
 *    ownership of the software is hereby transferred.                    
 *                                                                        
 *************************************************************************/

    class AprivaPaymentResp extends SimpleXMLElement {
     		
 		// Get the Result code.  0 is success all else is failure
		// Result codes vary by processor.
  		function GetResultCode()
  		{
  			return (int)$this->Credit->ResponseCode;
  		}
  
  		// Response text describes the result.  Varies by processor.
  		function GetResultTxt()
  		{
   			return (string)$this->Credit->ResponseText;
 		}

  		// Authorization ID or Approval Code from the prcessor.
  		function GetApprovalCode()
  		{
   			return (string)$this->Credit->AuthID;
  		}

 		// Reference Number from the processor
  		function GetReferenceNumber()
  		{
   			return (string)$this->Credit->RRN;
  		}
   
  		// Result of the CVV Check.  
  		function CVVValid()
  		{
   			if ($this->Credit->CardVerificationResponse->ResponseCode == "")
   				return false;
   				
   			if ($this->Credit->CardVerificationResponse->ResponseCode == "N")
   				return false;
   			return true; 
  		}
  		
 		// Result of the Postal Code Check.  Some processors will approve the 
		// transaction even with a failure.  Reversal can be used to cancel the transaction.
  		function PostalCodeValid()
  		{
   			if ($this->Credit->AddressVerifyResponse->ResponseCode == "")
   				return false;
   			if ($this->Credit->AddressVerifyResponse->ResponseCode == "N")
   				return false;
   			if ($this->Credit->CardVerificationResponse->ResponseCode == "A")
   				return false;
   			if ($this->Credit->CardVerificationResponse->ResponseCode == "B")
   				return false;
   			if ($this->Credit->CardVerificationResponse->ResponseCode == "C")
   				return false;
   			return true; 
  		}
    }
   ?>
