<?php
/*************************************************************************
 *    @file AprivaReversalReq.php                                         
 *    @brief Class to build a Credit Reversal Apriva XML Request.  A      
 *           Credit Reversal is used when a transction needs to be        
 *           canceled right away.  If the decision to cancel is later     
 *           in the day a void or refund must be used.                    
 *    @author P Heit                                                      
 *    @date Sept 21, 2013                                                 
 *                                                                        
 *    Copyright (c) 2013 by                                               
 *       Apriva LLC                                                       
 *    All rights reserved.                                                
 *                                                                        
 *    This software is furnished under a license and may be used and      
 *    copied only in accordance with the terms of such license and with   
 *    the inclusion of the above copyright notice. This software or       
 *    any other copies thereof may not be provided or otherwise made      
 *    available to any other person or entity. Neither title to nor       
 *    ownership of the software is hereby transferred.                    
 *                                                                        
 *************************************************************************/
     class AprivaReversalReq {
     	
     	private $xmlObj;
 
 		// Construct the default message    		
       	function __construct() {
 	       try {
	            $this->xmlObj = new SimpleXMLElement("<AprivaPosXml><Credit MessageType=\"Request\" Version=\"5.0\" ProcessingCode=\"SaleReversal\"></Credit></AprivaPosXml>");
    	    }
        	catch (Exception $e) {
            	throw new Exception("Exception (In AprivaReversalReq)" . $e . ")", PHP_ERRORS);
        	}

   		}    	
  
 		// Set the Account that the transaction had been run on   		
  		function SetMerchantNumber($mnum)
  		{
  			$this->xmlObj->addAttribute('DeviceAddress', $mnum);
 		}
  		
 		// Set the trace number of the transaction you wish to cancel.  
   		function SetSystemTraceNumber($stan)
  		{
 			$this->xmlObj->Credit->addChild('Stan');
 			$this->xmlObj->Credit->Stan = $stan;
  		}
  		 		
 		// Get the serialized object  		
  		function asXML()
  		{
  			return $this->xmlObj->asXML();
  		}
    }
   ?>
