<?php
/*************************************************************************
 *    @file onSubmit.php                                                  
 *    @Eclipse PHP Sample Version 1.1								          
 *    Copyright (c) 2018 Apriva LLC                                              
 *    All rights reserved.                                                
 *                                                                        
 *    This software is furnished under a license and may be used and      
 *    copied only in accordance with the terms of such license and with   
 *    the inclusion of the above copyright notice. This software or       
 *    any other copies thereof may not be provided or otherwise made      
 *    available to any other person or entity. Neither title to nor       
 *    ownership of the software is hereby transferred.                    
 *                                                                        
 *************************************************************************/

     // Turn on all error handling for debug purposes.
    ini_set('display_errors', 'On');
    error_reporting(E_ALL);

    // Include Apriva Classes to perform requests to the gateway.
	include 'AprivaPaymentReq.php';
	include 'AprivaPaymentResp.php';
	include 'AprivaReversalReq.php';
	include 'AprivaGW.php';
	
	getcwd() . "\n";
	
	// Initialize parameters.
	$ip="aibapp144.aprivaeng.com";          //Set the URL of the Gateway
	$port="11098";                  	   //Set the TCP Port of the Gateway
	$pem_filename = "AprivaDeveloper.pem"; //Set a filename for the PEM SSL Client Certificate.(Path assumes same directory)
	$capem_filename = "DigiCertGlobalRootCA.pem";       //Set a filename for the Servers Certificate Chain
	$deviceaddress = "7771314";
	$stan = "1";
	$ccnum = "4012000033330026";
	$expdate = "21/12";
	$amount = "1.00";
	$cardpresent = "1";
	$cvv = "999";
	$postal = "85251";
	
 	// Setup this page so that the XML can be dumped to the result window.
	header('Content-type: text/plain');
	date_default_timezone_set("America/Phoenix");
	echo date_format(date_create(), 'U = Y-m-d H:i:s') . "\n\n";
	
    // Output the some of the variables we will be submitting.
   	echo "DeviceAddress...", $deviceaddress, "\n";
   	echo "Card Number...", $ccnum, "\n";
   	echo "Expire Date...", $expdate, "\n";
   	echo "Amount...", $amount, "\n\n"; 

	// Note: The STAN comes in with the request.  This way if the person hits refresh on the 
	// browser the Trace Number stays the same and the host will handle duplicate checking. 
   	echo "STAN...", $stan, "\n";
	
	// Step 1:  Configure the Apriva Gateway SSL Connection
	$apriva = new AprivaGW($ip, $port, ini_get('default_socket_timeout'));
	$apriva->SetTracing(true);
	
	if (!$apriva->ConfigureClientCredentials($pem_filename))
		exit();
	
	if (!$apriva->ConfigureServerTrust(true, $capem_filename))
		exit();	
			
	// Step 2:  Build up your Apriva Payment Request
	$reqObj = new AprivaPaymentReq();
	$reqObj->SetMerchantNumber($deviceaddress);
	$reqObj->SetSystemTraceNumber($stan);
	//$reqObj->SetTrackData("4111111111111111=19061015432112345601"); // If card data was swiped
	$reqObj->SetManualCardData($ccnum, $expdate, $cardpresent);
	$reqObj->SetAmount($amount);
	$reqObj->SetPostalCode($postal);
	$reqObj->SetCvv($cvv);
	
	// 5 Customer fields available
	$reqObj->SetReportField(1, "User Defined Field 1");
	$reqObj->SetReportField(2, "User Defined Field 2");
	$reqObj->SetReportField(3, "User Defined Field 3");
	$reqObj->SetReportField(4, "User Defined Field 4");
	$reqObj->SetReportField(5, "User Defined Field 5");
	
	// Step 3:   Post the request to the Gateway. 

	// Step 3a:  Connect to the host.  The host disconnects on each response 
	//           so you will need to reconnect prior to each request.
	if (!$apriva->Connect())
		exit();	
	
	$resp = null;
	
	// Step 3b:  Send the request to the gateway
	if (!$apriva->ProcessRequest($reqObj, $resp))
	{	
		echo "Transaction Failed to send\n";
		exit();
	}
			
	//echo "$resp null: " .is_null($resp);
	
	// Step 4:  Parse the response
	echo "Response Text :", $resp->GetResultTxt(), "\n";
	echo "Authorization Code :", $resp->GetApprovalCode(), "\n";
	echo "Was Postal Code accepted :", $resp->PostalCodeValid() ? "Yes" : "No", "\n";

	// The Gateway is processing something so our request was rejected.
	if ($resp->GetResultCode() == "59" && $resp->GetResultTxt() == "Trans Processing")
		echo ('Transaction was blocked from processing by another transaction.\n');				
	
   ?>
